<?php
namespace HCM\AVL\Services;

use HCM\AVL\Repository\QuestionarioRepository;
use Doctrine\ORM\EntityManager;

class QuestionarioService {

    /**
     * @var questionarioRepository
     */
    protected $questionarioRepository;

    public function __construct(EntityManager $entityManager, QuestionarioRepository $questionarioRepository) {
        $this->entityManager = $entityManager;
        $this->questionarioRepository = $questionarioRepository;
    }

    /**
     * @return int
     */

    public function constroiObjeto($dados) {
      return $this->questionarioRepository->constroiObjeto($dados);
    }

    public function enviar($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg, $dataAtual) { 
      return $this->questionarioRepository->enviar($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg, $dataAtual);
    }

    public function getAlternativasQuestoes($nrquestao, $nrorg) {
      return $this->questionarioRepository->getAlternativasQuestoes($nrquestao, $nrorg);
    }

    public function getCabecalhoQuestionario($nravaliacao, $nrorg) {
      return $this->questionarioRepository->getCabecalhoQuestionario($nravaliacao, $nrorg);
    }

    public function getExecaval($nrcombquestaval, $nrparcavaliado, $nravaliacao, $nrquestao, $nrparcexecaval, $nrorg) {
      return $this->questionarioRepository->getExecaval($nrcombquestaval, $nrparcavaliado, $nravaliacao, $nrquestao, $nrparcexecaval, $nrorg);
    }

    public function getExecavaliacao($nravaliacao, $nrorg, $nrparnegocio) {
      return $this->questionarioRepository->getExecavaliacao($nravaliacao, $nrorg, $nrparnegocio);
    }

    public function getQuestoes($nravaliacao, $nrorg, $nravaliador, $nravaliado) {
      return $this->questionarioRepository->getQuestoes($nravaliacao, $nrorg, $nravaliador, $nravaliado);
    }

    public function getRespAvaliacao($nrexecavaliacao, $nrorg) {
      return $this->questionarioRepository->getRespAvaliacao($nrexecavaliacao, $nrorg);
    }

    public function getResposta($resposta, $nrorg) {
      return $this->questionarioRepository->getResposta($resposta, $nrorg);
    }

    public function insertExecavaliacao($dataSet) {
      $this->questionarioRepository->insertExecavaliacao($dataSet);
    }

    public function insertParticipaval($dataSet) {
      $this->questionarioRepository->insertParticipaval($dataSet);
    }

    public function insertRespavaliacao($nrrespavaliacao, $nrorg, $nrexecavaliacao, $resposta, $dsresposta, $dataAtual, $cdoperador) {
      return $this->questionarioRepository->insertRespavaliacao($nrrespavaliacao, $nrorg, $nrexecavaliacao, $resposta, $dsresposta, $dataAtual, $cdoperador);
    }

    public function updateExecavaliacao($dataAtual, $nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg) {
      return $this->questionarioRepository->updateExecavaliacao($dataAtual, $nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg);
    }

    public function updateParticipaval($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg) {
      return $this->questionarioRepository->updateParticipaval($nravaliacao, $nrparcexecaval, $nrparcavaliado, $nrcombquestaval, $nrorg);
    }

    public function updateRespAvaliacao($resposta, $dsresposta, $nrorg, $nrrespavaliacao) {
      return $this->questionarioRepository->updateRespAvaliacao($resposta, $dsresposta, $nrorg, $nrrespavaliacao);
    }

    public function verificaExistenciaParticipaval($dataSet) {
      $result = $this->questionarioRepository->verificaExistenciaParticipaval($dataSet);
      if($result['RESULT'] > 0){
        return false;
      } else {
        return true;
      }
    }
} 