<?php
namespace HCM\BTL\Repository;

use Doctrine\ORM\EntityManager;

class ProcessoSeletivoRepository {

    protected $entityManager;
    protected $hcmParameters;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getOperadorParcnegocio($nrorg, $nrparcnegocio) {
        $query = $this->entityManager->getConnection()->prepare("
                       SELECT DISTINCT CDOPERADOR
                         FROM OPERADOR O
                         JOIN PARCNEGOCIO P
                           ON O.NRPARCNEGOCIO = P.NRPARCNEGOCIO
                        WHERE (O.NRPARCNEGOCIO = '$nrparcnegocio') AND (O.NRORG = '$nrorg')");
        $query->execute();
        return $query->fetchAll()[0]['CDOPERADOR'];
    }

    public function setReprovados($parameters) {
      $queryProcesso = $this->entityManager->getConnection()->prepare("
            UPDATE DES_PARTICIPAPROCESSO
               SET CDSTATUS = :CDSTATUS
             WHERE NRORG = :NRORG
               AND NRPARCNEGOCIOCAND IN (SELECT NRPARCNEGOCIOCAND
                                           FROM DES_PARTICIPAFASE
                                          WHERE NRORG      = DES_PARTICIPAPROCESSO.NRORG
                                            AND NRPROCESSO = :NRPROCESSO
                                            AND NRFASE     = :NRFASE
                                            AND NRPONTUACAO IS NULL)
        ");

        $returnProcesso = $queryProcesso->execute(
            array(
                "NRORG"      => $parameters["NRORG"],
                "NRPROCESSO" => $parameters["NRPROCESSO"],
                "NRFASE"     => $parameters["NRFASE"],
                "CDSTATUS"   => 2
            )
        );    
        if($returnProcesso){
          $queryFase = $this->entityManager->getConnection()->prepare("
              UPDATE DES_PARTICIPAFASE
                 SET NRPONTUACAO  = :NRPONTUACAO,
                     IDSTATUS     = :IDSTATUS,
                     NRPERCENTUAL = :NRPERCENTUAL,
                     CDTIPORESU   = :CDTIPORESU
               WHERE NRORG = :NRORG
                 AND NRPARCNEGOCIOCAND IN (SELECT NRPARCNEGOCIOCAND
                                             FROM DES_PARTICIPAFASE PF
                                            WHERE PF.NRORG      = DES_PARTICIPAFASE.NRORG
                                              AND PF.NRPROCESSO = :NRPROCESSO
                                              AND PF.NRFASE     = :NRFASE
                                              AND PF.NRPONTUACAO IS NULL)
          ");

          $returnFase = $queryFase->execute(
              array(
                  "NRORG"        => $parameters["NRORG"],
                  "NRPROCESSO"   => $parameters["NRPROCESSO"],
                  "NRFASE"       => $parameters["NRFASE"],
                  "NRPONTUACAO"  => 0,
                  "NRPERCENTUAL" => 0,
                  "IDSTATUS"     => 8,
                  "CDTIPORESU"   => '02'
              )
          ); 
          if ($returnFase)
            return true;
          else
            return false;
        } else {
          return false;
        }      
    }

    public function setDtConclusaoProcesso($parameters) {
      $query = $this->entityManager->getConnection()->prepare("
            UPDATE DES_PROCESSO 
               SET DTCONCLUSAO = :DTATUAL
             WHERE NRPROCESSO = :NRPROCESSO 
               AND NRORG = :NRORG
        ");

        $return = $query->execute(
            array(
                "NRORG"      => $parameters["NRORG"],
                "NRPROCESSO" => $parameters["NRPROCESSO"],
                "DTATUAL"    => $parameters["DTATUAL"] 
            )
        );    
        
        if ($return)
          return true;
        else
          return false;    
    }

    public function setNrAvaliacao($parameters) {
      $query = $this->entityManager->getConnection()->prepare("
           UPDATE DES_PARTICIPAFASE 
              SET NRAVALIACAO       = :NRAVALIACAO 
            WHERE NRPARCTICIPAFASE  = :NRPARCTICIPAFASE
              AND NRFASE            = :NRFASE
              AND NRPARCNEGOCIOCAND = :NRPARCNEGOCIOCAND
              AND NRPROCESSO        = :NRPROCESSO
              AND NRORG             = :NRORG
        ");

        $return = $query->execute(
            array(
                "NRORG"             => $parameters["NRORG"],
                "NRPROCESSO"        => $parameters["NRPROCESSO"],
                "NRAVALIACAO"       => $parameters["NRAVALIACAO"],
                "NRPARCTICIPAFASE"  => $parameters["NRPARCTICIPAFASE"],
                "NRFASE"            => $parameters["NRFASE"],
                "NRPARCNEGOCIOCAND" => $parameters["NRPARCNEGOCIOCAND"] 
            )
        );    
        
        if ($return)
          return true;
        else
          return false;    
    }
}

