<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class ESocialEventoCadIniRepository {

    protected  $connection;

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    /*-------------------------- Métodos para retornar os dados do eventos -----------------------------------------------*/
    /**
     * @param $nrenvio
     * @param $nrchave
     * @return array    Associative array
     */
    public function getDadosS1000($nrenvio, $nrchave, $nrtpambiente, $dtmescompetenc) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PN.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END nrInsc,
       --idePeriodo
       TO_CHAR(GREATEST(EM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EM.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --infoCadastro
       EH.NMRAZSOCESTRUT nmRazao,
       CT.CDESOCIAL classTrib,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN ''ELSE EH.CDNATUJURI  END natJurid,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN ''ELSE '0' END indCoop,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN ''ELSE '0' END indConstr,
       CASE WHEN EH.VRALIQDESON > 0 THEN 1 ELSE 0 END indDesFolha,
       '' indOpcCP,
       '0' indOptRegEletron,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN ''ELSE 'N' END indEntEd,
       'N' indEtt,
       '' nrRegEtt,
       --dadosIsencao
       NULL dadosIsencao,
       '' ideMinLei,
       '' nrCertif,
       '' dtEmisCertif,
       '' dtVerncCertif,
       '' nrProtRenov,
       '' dtProtRenov,
       '' dtDou,
       '' pagDou,
       --contato
       PR.NMPRINCIPALPARC nmCtt,
       PR.NRINSCRICAOPARC cpfCtt,
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' '),'-'),'('),')'),'N/A')
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '01') foneFixo, -- 01=Telefone Principal
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' '),'-'),'('),')'),'N/A')
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '02') foneCel, -- 02=Celular Pessoal
       (SELECT MAX(C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '05') email, -- 05=Email
       --infoOP
       NULL infoOP,
       '' nrSiafi,
       --infoEFR
       '' infoEFR,
       '' ideEFR,
       '' cnpjEFR,
       --infoEnte
       '' infoEnte,
       '' nmEnte,
       '' uf,
       '' codMunic,
       '' indRPPS,
       '' subteto,
       '' vrSubteto,
       --infoOrgInternacional
       NULL infoOrgInternacional,
       '' indAcordoIsenMulta,
       --softwareHouse getDadosSoftwareHouse
       --infoComplementares
       '1' infoComplementares,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CNPJ'THEN '1'ELSE '' END situacaoPJ,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CNPJ'THEN '0'ELSE '' END indSitPJ,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN '1'ELSE '' END  situacaoPF,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF'THEN '0'ELSE '' END  indSitPF,
       '' novaValidade
       --TO_CHAR(EM.DTINIVIGENCIA, 'YYYY-MM') novaValidade_iniValid,
       --TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') novaValidade_fimValid
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    /*AND EH.DTMESCOMPETENC = P_DTMESCOMPETENCIA*/
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Responsável Legal da Estrutura*/
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND PR.NRORG = EH.NRORG
  LEFT JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            //"P_DTMESCOMPETENCIA" => $dtmescompetenc,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @return array    Associative array
     */
    public function getDadosSoftwareHouse() {
        $sql = <<<SQL
SELECT REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','') cnpjSofthouse,
       REPLACE(EH.NMRAZSOCESTRUT,'.','') nmRazao,
       REPLACE(NVL(PC.NMPRINCIPALPARC,EH.NMRAZSOCESTRUT),'.','') nmCont,
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' '),'-'),'('),')'),'N/A')
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '01') telefone, -- 01=Telefone Principal
       (SELECT MAX(C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '05') email -- 05=Email
  FROM PARCNEGOCIO PN
  JOIN ESTRUTURAM EM ON EM.NRORG = PN.NRORG
                    AND EM.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN PARCNEGOCIO PC ON PC.NRORG = EH.NRORG
                          AND PC.NRPARCNEGOCIO = EH.NRPARCRESPINF
 WHERE PN.NRORG = :P_NRORG
   AND PN.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
        $params = array(
            "P_NRORG" => 20,
            "P_NRPARCNEGOCIO" => 151000063, //Teknisa Service
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @return array    Associative array
     */
    public function getDadosS1005($nrenvio, $nrchave, $nrtpambiente, $dtmescompetenc) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PN.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoEstab
       --ideEstab
       CASE
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NULL) THEN '4'
            WHEN (EH.CDCEIESTRUT IS NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3' 
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3'
            ELSE DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2')
       END ideEstab_tpInsc,
       NVL(NVL(EH.CDCAEPFESTRUT,EH.CDCEIESTRUT),PN.NRINSCRICAOPARC) ideEstab_nrInsc,
       TO_CHAR(GREATEST(EM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EM.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosEstab
       EH.CDCNAE cnaePrep,
       --aliqGilrat
       CF.VRALIQRAT aliqRat,
       EH.VRFAP fap,
       (CF.VRALIQRAT * EH.VRFAP) aliqRatAjust,
       --procAdmJudRat
       '' procAdmJudRat,
       '' tpProc,
       '' nrProc,
       '' codSusp,
       --procAdmJudFap
       '' procAdmJudFap,
       --infoCaepf
       '' infoCaepf,
       '' tpCaepf,
       '' infoObra,
       --indSubstPatrObra
       '' indSubstPatrObra,
       --infoTrab
       NVL(RP.CDESOCIAL, '0') regPt,
       --infoApr
       DECODE(NVL(EE.QTDENTEDUC,0),0,'0','2') contApr,
       '' nrProcJud,
       DECODE(NVL(EE.QTDENTEDUC,0),0,'','S') contEntEd,
       --infoEntEduc getDadosInfoEntEduc
       --infoPCD
       '0' infoPCD,
       '' contPCD,
       '' novaValidade,
       EM.NRESTRUTURAM
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  LEFT JOIN CNAEFISCAL CF ON CF.CDCNAE = EH.CDCNAE
  LEFT JOIN (SELECT PA.NRORG, PA.NRESTRUTURAM, MAX(RP.CDESOCIAL) AS CDESOCIAL
               FROM GPE_PONTOACESSO PA
               JOIN GPE_TPREGIPONTO RP ON RP.NRTPREGIPONTO = PA.NRTPREGIPONTO
                                      AND RP.IDATIVO = 'S'
              WHERE PA.IDATIVO = 'S'
              GROUP BY PA.NRORG, PA.NRESTRUTURAM) RP ON RP.NRORG = EH.NRORG
                                                    AND RP.NRESTRUTURAM = EH.NRESTRUTURAM
  LEFT JOIN (SELECT HIERARQUIAORG.NRORG, HIERARQUIAORG.NRESTRUTURAMSUP, COUNT(DISTINCT ESTRUTHREL.CDCNPJESTRUT) QTDENTEDUC
               FROM HIERARQUIAORG
               JOIN ESTRUTURAM ESTRUTREL
                 ON HIERARQUIAORG.NRORG = ESTRUTREL.NRORG
                AND HIERARQUIAORG.NRESTRUTURAMREL = ESTRUTREL.NRESTRUTURAM
               JOIN ESTRUTURAH ESTRUTHREL
                 ON ESTRUTHREL.NRORG = ESTRUTREL.NRORG
                AND ESTRUTHREL.NRESTRUTURAM = ESTRUTREL.NRESTRUTURAM
                AND ESTRUTHREL.DTMESCOMPETENC = ( SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                   WHERE H1.NRORG = ESTRUTHREL.NRORG
                                                     AND H1.NRESTRUTURAM = ESTRUTHREL.NRESTRUTURAM
                                                     AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
              WHERE HIERARQUIAORG.NRTIPOHIERARQORG = 71
              GROUP BY HIERARQUIAORG.NRORG, HIERARQUIAORG.NRESTRUTURAMSUP) EE ON EE.NRORG = EH.NRORG
                                                                             AND EE.NRESTRUTURAMSUP = EH.NRESTRUTURAM
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave, 
            //"P_DTMESCOMPETENCIA" => $dtmescompetenc,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1005InfoEntEduc($nrestruturam) {
        $sql = <<<SQL
SELECT DISTINCT ESTRUTHREL.CDCNPJESTRUT nrInsc
  FROM HIERARQUIAORG
  JOIN ESTRUTURAM ESTRUTREL
    ON HIERARQUIAORG.NRORG = ESTRUTREL.NRORG
   AND HIERARQUIAORG.NRESTRUTURAMREL = ESTRUTREL.NRESTRUTURAM
  JOIN ESTRUTURAH ESTRUTHREL
    ON ESTRUTHREL.NRORG = ESTRUTREL.NRORG
   AND ESTRUTHREL.NRESTRUTURAM = ESTRUTREL.NRESTRUTURAM
   AND ESTRUTHREL.DTMESCOMPETENC = ( SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                      WHERE H1.NRORG = ESTRUTHREL.NRORG
                                        AND H1.NRESTRUTURAM = ESTRUTHREL.NRESTRUTURAM
                                        AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
 WHERE HIERARQUIAORG.NRORG = :P_NRORG
   AND HIERARQUIAORG.NRESTRUTURAMSUP = :P_NRESTRUTURAM
   AND HIERARQUIAORG.NRTIPOHIERARQORG = 71
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1010($nrenvio, $nrchave, $nrtabela, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NREVENTOM CHAVE, TM.NRTIPOMOVIMENT NRTABELA,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoRubrica
       --ideRubrica
       EM.NREVENTOM codRubr,
       TM.NRTIPOMOVIMENT ideTabRubr,
       --idePeriodo
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,EM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA,'YYYY-MM') fimValid,
       --dadosRubrica
       EH.NMEVENTOH dscRubr,
       NR.CDESOCIAL natRubr,
       /*1 - Vencimento, provento ou pensao; 2 - Desconto; 3 - Informativa; 4 - Informativa dedutora.*/
       CASE
         WHEN EM.NREVENTOM IN (1015) AND TM.NRTIPOMOVIMENT <> 10 THEN '3'
         WHEN EM.NREVENTOM IN (1290) AND TM.NRTIPOMOVIMENT = 1 THEN '4'
         WHEN EM.NREVENTOM IN (1310, 1510, 1520) AND TM.NRTIPOMOVIMENT = 1 THEN '2'
         WHEN EM.NREVENTOM NOT IN (331) AND EH.IDEVENTODEMONST = 'S' THEN '3'
         ELSE DECODE(EM.IDTIPOEVENTO,'PROVENTO','1','DESCONTO','2','ENCARGO','3','TOTAL','3')
       END tpRubr,
       NVL(CP.CDESOCIAL,'00') codIncCP,
       NVL(IRRF.CDESOCIAL,'00') codIncIRRF,
       NVL(FGTS.CDESOCIAL,'00') codIncFGTS,
       NVL(SIND.CDESOCIAL,'00') codIncSIND,
       DECODE(EM.NREVENTOM, DSR.NREVENTOM, 'S', 'N') repDSR,
       DECODE(EM.NREVENTOM, SAL13.NREVENTOM, 'S', 'N') rep13,
       DECODE(EM.NREVENTOM, FERIAS.NREVENTOM, 'S', 'N') repFerias,
       DECODE(EM.NREVENTOM, AVISO.NREVENTOM, 'S', 'N') repAviso,
       EH.DSOBSERVACAO observacao,
       --ideProcessoCP : CRIAR SELECT
       --ideProcessoIRRF : CRIAR SELECT
       --ideProcessoFGTS : CRIAR SELECT
       --ideProcessoSIND : CRIAR SELECT
       '' novaValidade
       --TO_CHAR(EM.DTINIVIGENCIA,'YYYY-MM') novaValidade_iniValid,
       --TO_CHAR(EM.DTFIMVIGENCIA,'YYYY-MM') novaValidade_fimValid
  FROM FPA_EVENTOM EM
  JOIN FPA_EVENTOH EH ON EH.NREVENTOM = EM.NREVENTOM
                     AND EH.NRORG = EM.NRORG
                     AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH H1
                                               WHERE H1.NREVENTOM = EH.NREVENTOM
                                                 AND H1.NRORG = EH.NRORG
                                                 AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Tipos de Movimento sao usados como tabela*/
  JOIN FPA_TIPOMOVIMENT TM ON TM.NRTIPOMOVIMENT IN (1,2,4,10,19,22)
  /*Natureza da Rubrica*/
  JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
  /*CONTRIBUICAO PREVIDENCIARIA NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                    AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) CP ON CP.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*IRRF NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                      AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) IRRF ON IRRF.NREVENTOM = EM.NREVENTOM
                AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*FGTS NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIAFGTS INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                      AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 48) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) FGTS ON FGTS.NREVENTOM = EM.NREVENTOM
                AND INSTR(','||FGTS.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*CONTRIBUICAO SINDICAL NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIASIND INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                      AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 49) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) SIND ON SIND.NREVENTOM = EM.NREVENTOM
                AND INSTR(','||SIND.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*REP DSR*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPDSR = 'S') DSR ON DSR.NREVENTOM = EM.NREVENTOM
  /*REP 13*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPDECTERC = 'S') SAL13 ON SAL13.NREVENTOM = EM.NREVENTOM
  /*REP FERIAS*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPFERIAS = 'S') FERIAS ON FERIAS.NREVENTOM = EM.NREVENTOM
  /*REP AVISO*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPAVISO = 'S') AVISO ON AVISO.NREVENTOM = EM.NREVENTOM
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE (EM.NRORG = :P_NRORG OR EM.NRORG = 0)
   AND EM.NREVENTOM = :P_NRCHAVE
   AND TM.NRTIPOMOVIMENT = :P_NRTABELA
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRTABELA" => $nrtabela,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1020($nrenvio, $nrchave, $nrestruturam, $nrtpambiente, $dtmescompetenc) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoLotacao
       --ideLotacao
       EM.NRESTRUTURAM codLotacao,
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,EM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EM.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosLotacao
       TL.CDESOCIAL tpLotacao,
       CASE WHEN TL.CDESOCIAL IN ('01', '10', '21', '24', '90', '91') THEN '' ELSE DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') END dadosLotacao_tpInsc,
       CASE WHEN TL.CDESOCIAL IN ('01', '10', '21', '24', '90', '91') THEN '' ELSE PN.NRINSCRICAOPARC END dadosLotacao_nrInsc,
       --fpasLotacao
       EH.CDFPAS fpas,
       EH.CDTERCEIRO codTercs,
       '' codTercsSusp,
       --infoProcJudTerceiros
       --procJudTerceiro : CRIAR SELECT
       --infoEmprParcial
       DECODE(TL.CDESOCIAL,'02','','') tpInscContrat,
       DECODE(TL.CDESOCIAL,'02','','') nrInscContrat,
       DECODE(TL.CDESOCIAL,'02','','') tpInscProp,
       DECODE(TL.CDESOCIAL,'02','','') nrInscProp
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    /*AND EH.DTMESCOMPETENC = P_DTMESCOMPETENCIA*/
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Tipo Lotação*/
  JOIN TIPOESTRUTURA TE ON TE.NRTIPOESTRUTURA = EM.NRTIPOESTRUTURA
                       AND (TE.NRORG = EM.NRORG OR TE.NRORG = 0)
  LEFT JOIN ESO_TPLOTATRIBUT TL ON TL.NRTPLOTATRIBUT = TE.NRTPLOTATRIBUT
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
   AND (EM.NRTIPOESTRUTURA = NVL(:P_NRTIPOESTRUTOMADOR, 7) OR EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL)
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam, 
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg()
            //"P_DTMESCOMPETENCIA" => $dtmescompetenc
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1030($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT OM.NROCUPACAOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoCargo
       --ideCargo
       OM.NROCUPACAOM codCargo,
       --idePeriodo
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,OM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(OM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosCargo
       OH.NMOCUPACAOH nmCargo,
       LPAD(OH.NRCBO,6,'0') codCBO
       --cargoPublico
       --leiCargo
  FROM GPE_OCUPACAOM OM
  JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = OM.NROCUPACAOM
                       AND OH.NRORG = OM.NRORG
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE OM.NRORG = :P_NRORG
   AND OM.NROCUPACAOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1040($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT OM.NROCUPACAOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoFuncao
       --ideFuncao
       OM.NROCUPACAOM codFuncao,
       --idePeriodo
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,OM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(OM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosFuncao
       OH.NMOCUPACAOH dscFuncao,
       LPAD(OH.NRCBO,6,'0') codCBO
  FROM GPE_OCUPACAOM OM
  JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = OM.NROCUPACAOM
                       AND OH.NRORG = OM.NRORG
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE OM.NRORG = :P_NRORG
   AND OM.NROCUPACAOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1050($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT HH.NRHORDIAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoHorContratual
       --ideHorContratual
       HH.NRHORDIAM codHorContrat,
       --idePeriodo
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,HM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(HM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosHorContratual
       TO_CHAR(TO_DATE(CASE WHEN IHE.HRENTRADA > '2359' THEN '00'||SUBSTR(IHE.HRENTRADA,3,2) ELSE IHE.HRENTRADA END, 'HH24:MI:SS'), 'HH24MI') hrEntr,
       TO_CHAR(TO_DATE(CASE WHEN IHS.HRSAIDA > '2359' THEN '00'||SUBSTR(IHS.HRSAIDA,3,2) ELSE IHS.HRSAIDA END, 'HH24:MI:SS'), 'HH24MI') hrSaida,
       (SELECT SUM(ROUND(60*
                (24*
                    ROUND(
                        (TO_DATE(CASE WHEN IH.HRSAIDA > '2359' THEN '00'||SUBSTR(IH.HRSAIDA,3,2) ELSE IH.HRSAIDA END, 'HH24:MI:SS') + DECODE(CASE WHEN IH.HRSAIDA > '2359' THEN 'DS' ELSE IH.IDDIAOCORRESAIDA END,'FA',1,'DA',1,'DS',-1,'FS',-1,0))
                        -
                        (TO_DATE(CASE WHEN IH.HRENTRADA > '2359' THEN '00'||SUBSTR(IH.HRENTRADA,3,2) ELSE IH.HRENTRADA END, 'HH24:MI:SS') + DECODE(IH.IDDIAOCORREENTRADA,'FA',1,'DA',1,'DS',-1,'FS',-1,0))
                    ,4)
                )
               )) DURJORNADA
          FROM GPE_INTERVALOSHORARIO IH
         WHERE IH.NRHORDIAM = HH.NRHORDIAM
           AND IH.NRORG = HH.NRORG
       ) durJornada,
       'S' perHorFlexivel,
       --horarioIntervalo : getDadosS1050horarioIntervalo
       HH.NRORG, HH.NRHORDIAM
  FROM GPE_HORDIAM HM
  JOIN GPE_HORDIAH HH ON HH.NRHORDIAM = HM.NRHORDIAM
                     AND HH.NRORG = HM.NRORG
                     AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                    FROM GPE_HORDIAH
                                                   WHERE GPE_HORDIAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                     AND GPE_HORDIAH.NRORG = HH.NRORG)
  LEFT JOIN GPE_INTERVALOSHORARIO IHE ON IHE.NRHORDIAM = HH.NRHORDIAM
                                     AND IHE.NRORG = HH.NRORG
                                     AND IHE.NRINTERVALOHORARIO = (SELECT MIN(NRINTERVALOHORARIO) FROM GPE_INTERVALOSHORARIO WHERE NRHORDIAM = IHE.NRHORDIAM AND NRORG = IHE.NRORG)
  LEFT JOIN GPE_INTERVALOSHORARIO IHS ON IHS.NRHORDIAM = HH.NRHORDIAM
                                     AND IHS.NRORG = HH.NRORG
                                     AND IHS.NRINTERVALOHORARIO = (SELECT MAX(NRINTERVALOHORARIO) FROM GPE_INTERVALOSHORARIO WHERE NRHORDIAM = IHS.NRHORDIAM AND NRORG = IHS.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE (HM.NRORG = :P_NRORG OR HM.NRORG = 0)
   AND HH.IDTIPOHORARIO <> 'F'
   AND HH.NRHORDIAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrhordiam
     * @return array    Associative array
     */
    public function getDadosS1050horarioIntervalo($nrorg, $nrhordiam) {
        $sql = <<<SQL
SELECT NVL(TI.CDESOCIAL, '1') tpInterv,
       TO_CHAR(TO_DATE(IH.HRPROJETARINTERVALO, 'HH24:MI:SS'), 'SSSSS') / 60 durInterv,
       DECODE(TI.CDESOCIAL, '2', '', (SELECT HRSAIDA
                                        FROM GPE_INTERVALOSHORARIO
                                       WHERE NRHORDIAM = IH.NRHORDIAM
                                         AND NRORG = IH.NRORG
                                         AND NRSEQINTERVHORARIO = (IH.NRSEQINTERVHORARIO) )) AS iniInterv,
       DECODE(TI.CDESOCIAL, '2', '', (SELECT HRENTRADA
                                        FROM GPE_INTERVALOSHORARIO
                                       WHERE NRHORDIAM = IH.NRHORDIAM
                                         AND NRORG = IH.NRORG
                                         AND NRSEQINTERVHORARIO = (IH.NRSEQINTERVHORARIO) + 1 )) AS termInterv
  FROM GPE_INTERVALOSHORARIO IH
  LEFT JOIN PTO_TIPOINTERVALO TI ON TI.NRTPINTERVALO = IH.NRTPINTERVALO
 WHERE IH.NRORG = :P_NRORG
   AND IH.NRHORDIAM  = :P_NRHORDIAM
   AND IH.HRPROJETARINTERVALO IS NOT NULL
   AND (SELECT COUNT(*) FROM GPE_INTERVALOSHORARIO H1 WHERE H1.NRORG = IH.NRORG AND H1.NRHORDIAM = IH.NRHORDIAM) > 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRHORDIAM" => $nrhordiam
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1060($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoAmbiente
       --ideAmbiente
       EM.NRESTRUTURAM codAmb,
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,EM.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosAmbiente
       EH.NMESTRUTURAH nmAmb,
       EH.NMESTRUTURAH dscAmb,
       CASE WHEN NVL(TOP.CDTIPOINSCRICAO, 'LIVRE') IN ('LIVRE', 'CODIGO') THEN '1' ELSE '2' END localAmb,
       DECODE(CASE WHEN NVL(TOP.CDTIPOINSCRICAO, 'LIVRE') IN ('LIVRE', 'CODIGO') THEN PAR.CDTIPOINSCRICAO ELSE TOP.CDTIPOINSCRICAO END,'CNPJ','1','CPF','3','') dadosAmbiente_tpInsc,
       CASE WHEN NVL(TOP.CDTIPOINSCRICAO, 'LIVRE') IN ('LIVRE', 'CODIGO') THEN (CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END) ELSE TOP.NRINSCRICAOPARC END dadosAmbiente_nrInsc,
       --fatorRisco : getDadosS1060fatorRisco
       EM.NRORG, EM.NRESTRUTURAM
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Tomador*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
                             AND TH.NRTIPOESTRUTREL = EM.NRTIPOESTRUTURA
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = EM.NRESTRUTURAM
  LEFT JOIN ESTRUTURAM TOM ON TOM.NRORG = EM.NRORG
                          AND TOM.NRESTRUTURAM = HO.NRESTRUTURAMSUP
  LEFT JOIN PARCNEGOCIO TOP ON TOP.NRORG = TOM.NRORG
                           AND TOP.NRPARCNEGOCIO = TOM.NRPARCNEGOCIO
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrorg
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1060fatorRisco($nrorg, $nrestruturam) {
        $sql = <<<SQL
SELECT RA.CDESOCIAL codFatRis
  FROM SST_RELESTRUTRISCO ER
  JOIN SST_FATORRISCO FR ON FR.NRORG = ER.NRORG
                        AND FR.NRFATORRISCO = ER.NRFATORRISCO
  JOIN GPE_FATRISCAMB RA ON RA.NRFATRISCAMB = FR.NRFATRISCAMB
 WHERE ER.NRORG = :P_NRORG
   AND ER.NRESTRUTURAM = :P_NRESTRUTURAM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1070($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT PR.NRPROCESSADMJUD CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --ideProcesso
       PR.NRTPPROCESSADJU tpProc,
       REPLACE(REPLACE(PR.CDPROCESSADMJUD,'.',''),'-','') nrProc,
       --idePeriodo
       TO_CHAR(GREATEST(EMP.DTINIVIGENCIA,PR.DTINIVIGENCIA,TO_DATE(DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR))),'YYYY-MM') iniValid,
       TO_CHAR(PR.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosProc
       DECODE(PN.NRINSCRICAOPARC,EH.CDCNPJESTRUT,'1','2') indAutoria,
       MA.CDESOCIAL indMatProc,
       --dadosProcJud
       PR.SGUFVARAPROADJU ufVara,
       MU.CDMUNICIBGE codMunic,
       PR.CDVARAPROCEADJU idVara,
       --infoSusp :
       PR.NRORG, PR.NRPROCESSADMJUD
  FROM GPE_PROCESSADMJUD PR
  JOIN ESTRUTURAH EH ON EH.NRORG = PR.NRORG
                    AND EH.NRESTRUTURAM = PR.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EH.NRESTRUTURAM
                                                  AND NRORG = EH.NRORG)
  /*Materia*/
  LEFT JOIN GPE_MATEPROCADJU MA ON MA.NRMATERPROCADJU = PR.NRMATERPROCADJU
  /*Autoria*/
  LEFT JOIN PARCNEGOCIO PN ON PN.NRORG = PR.NRPARCNEGOCIO
                     AND PN.NRPARCNEGOCIO = PR.NRPARCNEGOCIO
  /*Vara*/
  LEFT JOIN MUNICIPIO MU ON MU.CDMUNICIPIO = PR.CDMUNIVARPRADJU
                        AND (MU.NRORG = PR.NRORG OR MU.NRORG = 0)
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE PR.NRORG = :P_NRORG
   AND PR.NRPROCESSADMJUD = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidCadIniProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidCadIniProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidCadIniNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrorg
     * @param $nrprocessadmjud
     * @return array    Associative array
     */
    public function getDadosS1070infoSusp($nrorg, $nrprocessadmjud) {
        $sql = <<<SQL
SELECT IP.NRITEMPROCADMJUD codSusp,
       SE.CDESOCIAL indSusp,
       TO_CHAR(IP.DTITEMPROCADMJUD, 'YYYY-MM-DD') dtDecisao,
       IP.IDDEPOMONTITPROC indDeposito
  FROM GPE_ITEMPROCADMJUD IP
  LEFT JOIN GPE_SUSPEXIGITPROC SE ON SE.NRSUSPEXIGITPROC = IP.NRSUSPEXIGITPROC
 WHERE IP.NRORG = :P_NRORG
   AND IP.NRPROCESSADMJUD = :P_NRPROCESSADMJUD
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRPROCESSADMJUD" => $nrprocessadmjud
        );
        return $this->connection->fetchAll($sql, $params);
    }

}