/* SELECTS DOS INTERVALOS (INTRAJORNADA/INTERJORNADA) E TOATIALIZADORES (ABONO, FALTA, EXTRA, IMPAR, ATRASO) */
WITH TOTALIZADORES AS ( /* SELECT QUE BUSCA AS TOTALIZAÇÕS, POR DIA, DE ABONO, FALTA, EXTRA, IMPAR E ATRASO */
    SELECT
        VM.NRORG,
        VM.NRVINCULOM,
        VM.NMVINCULOM,
        PH.NRPISPASEPPES,
        DT.DTDATA,
        PA.NRPERIODOAPURACAO,
        /* OCORRENCIA DE ABONO EXISTENTE */
        CASE
            WHEN OC_ABONA_FALTA.NRPROGOCORRENCIA IS NOT NULL /*THEN NVL(MO.DSMOTIVOOCORFREQ, 'Falta abonada')*/ THEN
                DECODE(OC_ABONA_FALTA.NRMOTIVOOCORFREQ, 22, 'AB_FERI - Férias', 5, 'AB_ATME - Atestado Médico', 14, 'AB_INSS - Afastado INSS', 15, 'AB_LMAT - Licença Maternidade', 'Falta abonada')
            ELSE
                NULL
        END ABONO,
        /* TROCA DE HORARIO */
        CASE
            WHEN OC_TROCA_HORARIO.NRPROGOCORRENCIA IS NOT NULL THEN
                'AB_TROC - Troca de Horário (' || HH.NMHORDIAH || ')'
            ELSE
                NULL
        END TROCA,
        /* SITUACOES DE FALTA E ATRASO */
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND NVL(CALCULO_INTERVALOS.VALOR, 0) = 0
                 AND OC_ABONA_FALTA.NRPROGOCORRENCIA IS NULL THEN
                'Falta injustificada'
            ELSE
                NULL
        END FALTA,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL THEN
                'Atraso injustificado'
            ELSE
                NULL
        END ATRASO,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL THEN
                TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR
            ELSE
                NULL
        END VALOR_ATRASO_HOURS,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL THEN
                LPAD(TRUNC(TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR), 2, '0') || ':' || LPAD(ROUND((((TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR) - TRUNC(TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR)) * 60)), 2, '0')
            ELSE
                NULL
        END VALOR_ATRASO_TIME,
        /* EXISTENCIA DE TEMPO ALEM DA JORANADA */
    CASE
        WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
             OR ( HH.IDTIPOHORARIO = 'F'
                  AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
            CASE
        WHEN :P_VALOR IS NOT NULL
             AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
            'Tempo extra realizado SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
        WHEN :P_VALOR IS NOT NULL
             AND :P_CONDICAO = 'MENOR_IGUAL' THEN
            'Tempo extra realizado INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
        ELSE
            'Tempo extra realizado'
        END ELSE NULL
    END EXTRA,
        CASE
            WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
                 OR ( HH.IDTIPOHORARIO = 'F'
                      AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
                CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR
            ELSE
                NULL
        END VALOR_EXTRA_HOURS,
        CASE
            WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
                 OR ( HH.IDTIPOHORARIO = 'F'
                      AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
                LPAD(TRUNC(CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR), 2, '0') || ':' || LPAD(ROUND((((CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR) - TRUNC(CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR)) * 60)), 2, '0')
            ELSE
                NULL
        END VALOR_EXTRA_TIME,
        /* QUANTIDADE IMPAR DE MARCACOES NO DIA */
        CASE
            WHEN MARCACOES_IMPARES.DTHRAJUSTADA IS NOT NULL THEN
                'Quantidade ímpar de marcações'
            ELSE
                NULL
        END QTD_MARCACAOES_IMPAR
    FROM
        GPE_VINCULOM          VM
        JOIN GPE_VINCULOH          VH ON VH.NRVINCULOM = VM.NRVINCULOM
                                AND VH.NRORG = VM.NRORG
                                AND VH.DTMESCOMPETENC IN (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_VINCULOH VIH
            WHERE
                VIH.NRVINCULOM = VH.NRVINCULOM
                AND VIH.NRORG = VH.NRORG
                AND TO_CHAR(VIH.DTMESCOMPETENC, 'DD/MM/YYYY') <= :P_DTMESCOMPETENC
        )
        JOIN GPE_PESSOAH           PH ON PH.NRORG = VM.NRORG
                               AND PH.NRPESSOA = VM.NRPESSOA
                               AND PH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_PESSOAH
            WHERE
                NRORG = PH.NRORG
                AND NRPESSOA = PH.NRPESSOA
                AND DTMESCOMPETENC < LAST_DAY(:P_DTMESCOMPETENC)
        )
        JOIN PTO_PERIODOAPURACAO   PA ON PA.NRORG = VM.NRORG
                                       AND PA.NRPERIODOAPURACAO = :NRPERIODOAPURACAO
        JOIN DATA                  DT ON DT.DTDATA BETWEEN PA.DTINICIALAPURACAO AND PA.DTFINALAPURACAO
        
        /* OCORRENCIAS DE FREQUENCIA */
        LEFT JOIN PTO_PROGOCORRENCIA    OC_ABONA_FALTA ON OC_ABONA_FALTA.NRORG = VM.NRORG
                                                       AND OC_ABONA_FALTA.NRVINCULOM = VM.NRVINCULOM
                                                       AND DT.DTDATA BETWEEN OC_ABONA_FALTA.DTINICIOPROGOCOR AND NVL(OC_ABONA_FALTA.DTFIMPROGOCOR, DT.DTDATA)
                                                       AND OC_ABONA_FALTA.IDATIVO = 'S'
                                                       AND OC_ABONA_FALTA.NRTIPOPROGOCORRENCIA = 5
                                                       AND SUBSTR(OC_ABONA_FALTA.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
        LEFT JOIN PTO_PROGOCORRENCIA    OC_ABONO_SAIDA ON OC_ABONO_SAIDA.NRORG = VM.NRORG
                                                       AND OC_ABONO_SAIDA.NRVINCULOM = VM.NRVINCULOM
                                                       AND DT.DTDATA BETWEEN OC_ABONO_SAIDA.DTINICIOPROGOCOR AND NVL(OC_ABONO_SAIDA.DTFIMPROGOCOR, DT.DTDATA)
                                                       AND OC_ABONO_SAIDA.IDATIVO = 'S'
                                                       AND OC_ABONO_SAIDA.NRTIPOPROGOCORRENCIA IN (
                                                            4,
                                                            16,
                                                            17,
                                                            23
                                                        )
                                                        AND SUBSTR(OC_ABONO_SAIDA.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
        LEFT JOIN PTO_PROGOCORRENCIA    OC_TROCA_HORARIO ON OC_TROCA_HORARIO.NRORG = VM.NRORG
                                                         AND OC_TROCA_HORARIO.NRVINCULOM = VM.NRVINCULOM
                                                         AND DT.DTDATA BETWEEN OC_TROCA_HORARIO.DTINICIOPROGOCOR AND NVL(OC_TROCA_HORARIO.DTFIMPROGOCOR, DT.DTDATA)
                                                         AND OC_TROCA_HORARIO.IDATIVO = 'S'
                                                         AND OC_TROCA_HORARIO.NRTIPOPROGOCORRENCIA = 29
                                                         AND SUBSTR(OC_TROCA_HORARIO.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
                                                         
        /* ALTERACAO DE ESCALA MAIS RECENTE PARA O DIA */
        LEFT JOIN GPE_ALTEESCALA        AE ON AE.NRORG = VM.NRORG
                                       AND AE.NRVINCULOM = VM.NRVINCULOM
                                       AND AE.NRTURNO IS NOT NULL
                                       AND AE.DTINIESCALA = (
            SELECT
                MAX(DTINIESCALA)
            FROM
                GPE_ALTEESCALA
            WHERE
                NRORG = AE.NRORG
                AND NRVINCULOM = AE.NRVINCULOM
                AND DT.DTDATA BETWEEN DTINIESCALA AND NVL(DTFIMESCALA, DT.DTDATA)
        )
        LEFT JOIN GPE_TURNO             T ON T.NRORG = VM.NRORG
                                 AND T.NRTURNO = AE.NRTURNO
                                 
        /* HORARIO DO DIA */
        LEFT JOIN GPE_HORARIOTURNO      HT ON HT.NRORG = VM.NRORG
                                         AND HT.NRTURNO = AE.NRTURNO
                                         AND NRSEQHORARIO = ( /* BUSCA ENTRE OS HORARIOS DO TURNO QUAL E O HORARIO DO DIA EM QUESTAO */
            SELECT
                MOD((DT.DTDATA - TRUNC(T.DTDATABASE)), COUNT(*)) + 1
            FROM
                GPE_HORARIOTURNO
            WHERE
                NRORG = HT.NRORG
                AND NRTURNO = HT.NRTURNO
        )
        
        /* DADOS DO HORARIO DO DIA */
        LEFT JOIN GPE_HORDIAH           HH ON HH.NRORG = VM.NRORG
                                    AND HH.NRHORDIAM = NVL(OC_TROCA_HORARIO.NRHORDIAM, HT.NRHORDIAM)
                                    AND HH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_HORDIAH
            WHERE
                NRORG = HH.NRORG
                AND NRHORDIAM = HH.NRHORDIAM
                AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        )
        
        /* SOMA O TEMPO DOS INTERVALOS DO HORARIO */
        LEFT JOIN (
            SELECT
                HM.NRORG,
                HM.NRHORDIAM,
                NVL(SUM(
                    (ROUND(TO_NUMBER(SUBSTR(IH.HRSAIDA, 0, 2)) + (TO_NUMBER(SUBSTR(IH.HRSAIDA, 3, 4)) / 60), 5)) - (ROUND(TO_NUMBER(SUBSTR(IH.HRENTRADA, 0, 2)) + (TO_NUMBER(SUBSTR(IH.HRENTRADA, 3, 4)) / 60), 5))
                    + (
                        /* CONSIDERA SITUACOES DE VIRADA DE DIA NO CALCULO */
                        CASE
                            WHEN SUBSTR(IH.IDDIAOCORREENTRADA, 2, 1) <> SUBSTR(IH.IDDIAOCORRESAIDA, 2, 1) THEN 24
                            ELSE 0
                        END
                    )
                ), 0) AS VALOR
            FROM
                GPE_HORDIAM             HM
                LEFT JOIN GPE_INTERVALOSHORARIO   IH ON IH.NRORG = HM.NRORG
                                                      AND IH.NRHORDIAM = HM.NRHORDIAM
            WHERE
                HM.NRORG = :P_NRORG
            GROUP BY
                HM.NRORG,
                HM.NRHORDIAM
        ) TEMPO_JORNADA ON TEMPO_JORNADA.NRHORDIAM = HH.NRHORDIAM
        
        /* SOMA O TEMPO DOS INTERVALOS DAS BATIDAS DE PONTO */
        LEFT JOIN (
            SELECT
                INTERVALOS_TRABALHO.NRORG,
                INTERVALOS_TRABALHO.NRVINCULOM,
                INTERVALOS_TRABALHO.DATA_APURACAO,
                SUM(ROUND(((INTERVALOS_TRABALHO.DTHRAJUSTADA_FIM - INTERVALOS_TRABALHO.DTHRAJUSTADA) * 24), 5)) VALOR
            FROM
                (
                    SELECT
                        MARCACOES_SEQUENCIADAS.*
                    FROM
                        (
                            SELECT
                                ROW_NUMBER() OVER(
                                    PARTITION BY NRORG, NRVINCULOM, DATA_APURACAO
                                    ORDER BY
                                        DTHRAJUSTADA
                                ) AS SEQUENCIA_INTERVALO,
                                MARCACAO_DIA.*,
                                LEAD(DTHRAJUSTADA, 1, TO_DATE('01/01/0001')) OVER(
                                    PARTITION BY NRORG, NRVINCULOM, DATA_APURACAO
                                    ORDER BY
                                        NRORG, NRVINCULOM, DATA_APURACAO
                                ) DTHRAJUSTADA_FIM
                            FROM
                                (
                                    SELECT
                                        MP.NRORG,
                                        MP.NRMARCACAOPONTO,
                                        MP.NRVINCULOM,
                                        MP.DTHRMARCACAOPONTO,
                                        MP.DTHRAJUSTADA,
                                        MP.IDDIAOCORRENCIA,
                                        CASE
                                            WHEN MP.IDDIAOCORRENCIA IN ('FA','DA') THEN
                                                TRUNC(DTHRAJUSTADA) - 1
                                            WHEN MP.IDDIAOCORRENCIA IN ('FS','DS') THEN
                                                TRUNC(DTHRAJUSTADA) + 1
                                            ELSE
                                                TRUNC(DTHRAJUSTADA)
                                        END DATA_APURACAO
                                    FROM
                                        GPE_MARCACAOPONTO     MP
                                        LEFT JOIN PTO_PERIODOAPURACAO   PA ON PA.NRORG = MP.NRORG
                                                                            AND PA.NRPERIODOAPURACAO = :NRPERIODOAPURACAO
                                    WHERE
                                        MP.NRORG = :P_NRORG
                                        AND (
                                            CASE
                                                WHEN MP.IDDIAOCORRENCIA IN (
                                                    'FA',
                                                    'DA'
                                                ) THEN
                                                    TRUNC(MP.DTHRAJUSTADA) - 1
                                                WHEN MP.IDDIAOCORRENCIA IN (
                                                    'FS',
                                                    'DS'
                                                ) THEN
                                                    TRUNC(MP.DTHRAJUSTADA) + 1
                                                ELSE
                                                    TRUNC(MP.DTHRAJUSTADA)
                                            END
                                        ) BETWEEN PA.DTINICIALAPURACAO AND PA.DTFINALAPURACAO
                                        AND MP.NRCOLETOR NOT IN (
                                            SELECT
                                                NRCOLETOR
                                            FROM
                                                GPE_PARAMORG UNPIVOT ( NRCOLETOR
                                                    FOR NRCOLETOR_TIPO
                                                IN ( NRCOLETORMARCAUTOM,
                                                     NRCOLETORMARCGERSIST,
                                                     NRCOLETORMARCVIRADIA,
                                                     NRCOLETORMARCPROJETADA ) )
                                            WHERE
                                                NRORG = MP.NRORG
                                        )
                                    ORDER BY
                                        MP.DTHRMARCACAOPONTO
                                ) MARCACAO_DIA
                        ) MARCACOES_SEQUENCIADAS
                    WHERE
                        DTHRAJUSTADA_FIM <> '01/01/0001'
                        AND MOD(SEQUENCIA_INTERVALO, 2) <> 0
                ) INTERVALOS_TRABALHO
            GROUP BY
                NRORG,
                NRVINCULOM,
                DATA_APURACAO
        ) CALCULO_INTERVALOS ON CALCULO_INTERVALOS.NRVINCULOM = VM.NRVINCULOM
                                AND CALCULO_INTERVALOS.DATA_APURACAO = DT.DTDATA
                                
        /* MARCACOES IMPARES */
        LEFT JOIN (
            SELECT
                NRVINCULOM,
                DTHRAJUSTADA
            FROM
                (
                    SELECT
                        NRVINCULOM,
                        DTHRAJUSTADA,
                        COUNT(*) AS QTD_MARCACAOES
                    FROM
                        (
                            SELECT
                                NRVINCULOM,
                                CASE
                                    WHEN MARC.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
                                        TRUNC(MARC.DTHRAJUSTADA) - 1
                                    WHEN MARC.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
                                        TRUNC(MARC.DTHRAJUSTADA) + 1
                                    ELSE
                                        TRUNC(MARC.DTHRAJUSTADA)
                                END AS DTHRAJUSTADA
                            FROM
                                GPE_MARCACAOPONTO     MARC
                                LEFT JOIN PTO_PERIODOAPURACAO   PA ON PA.NRORG = MARC.NRORG
                                                                    AND PA.NRPERIODOAPURACAO = :NRPERIODOAPURACAO
                            WHERE
                                MARC.NRORG = :P_NRORG
                                AND (
                                    CASE
                                        WHEN MARC.IDDIAOCORRENCIA IN (
                                            'FA',
                                            'DA'
                                        ) THEN
                                            TRUNC(MARC.DTHRAJUSTADA) - 1
                                        WHEN MARC.IDDIAOCORRENCIA IN (
                                            'FS',
                                            'DS'
                                        ) THEN
                                            TRUNC(MARC.DTHRAJUSTADA) + 1
                                        ELSE
                                            TRUNC(MARC.DTHRAJUSTADA)
                                    END
                                ) BETWEEN PA.DTINICIALAPURACAO AND PA.DTFINALAPURACAO
                                AND MARC.NRCOLETOR NOT IN (
                                    SELECT
                                        NRCOLETOR
                                    FROM
                                        GPE_PARAMORG UNPIVOT ( NRCOLETOR
                                            FOR NRCOLETOR_TIPO
                                        IN ( NRCOLETORMARCAUTOM,
                                             NRCOLETORMARCGERSIST,
                                             NRCOLETORMARCVIRADIA,
                                             NRCOLETORMARCPROJETADA ) )
                                    WHERE
                                        NRORG = MARC.NRORG
                                )
                        )
                    GROUP BY
                        NRVINCULOM,
                        DTHRAJUSTADA
                )
            WHERE
                MOD(QTD_MARCACAOES, 2) <> 0
        ) MARCACOES_IMPARES ON MARCACOES_IMPARES.NRVINCULOM = VM.NRVINCULOM
                               AND MARCACOES_IMPARES.DTHRAJUSTADA = DT.DTDATA
    WHERE
        VM.NRORG = :P_NRORG
        /* FILTROS DE VINCULOS */
        AND ( VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC > LAST_DAY(PA.DTFINALAPURACAO) )
        AND ( INSTR(:NRVINCULOM_LIST, ',' || VM.NRVINCULOM || ',') > 0 OR :NRVINCULOM_LIST IS NULL )
        AND ( INSTR(:NRESTRUTLEGAL_LIST, ',' || VH.NRESTRUTLEGAL || ',') > 0 OR :NRESTRUTLEGAL_LIST IS NULL )
        AND ( INSTR(:NRESTRUTGEREN_LIST, ',' || VH.NRESTRUTGEREN || ',') > 0
              OR :NRESTRUTGEREN_LIST IS NULL )
),

BATIDAS_DIA AS (
    SELECT
        M.NRORG,
        M.NMVINCULOM,
        M.NRVINCULOM,
        PH.NRPISPASEPPES,
        PA.NRPERIODOAPURACAO,
        MARC.DTHRAJUSTADA,
        MARC.IDDIAOCORRENCIA,
        MARC.NRMARCACAOPONTO,
        CASE
            WHEN MARC.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
                TRUNC(DTHRAJUSTADA) - 1
            WHEN MARC.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
                TRUNC(DTHRAJUSTADA) + 1
            ELSE
                TRUNC(DTHRAJUSTADA)
        END DATA_APURACAO
    FROM
        GPE_VINCULOM          M
        JOIN GPE_VINCULOH          H ON H.NRVINCULOM = M.NRVINCULOM
                               AND H.NRORG = M.NRORG
                               AND H.DTMESCOMPETENC IN (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_VINCULOH VIH
            WHERE
                VIH.NRVINCULOM = H.NRVINCULOM
                AND VIH.NRORG = H.NRORG
                AND TO_CHAR(VIH.DTMESCOMPETENC, 'DD/MM/YYYY') <= :P_DTMESCOMPETENC
        )
        JOIN PTO_PERIODOAPURACAO   PA ON PA.NRORG = M.NRORG
                                       AND PA.NRPERIODOAPURACAO = :NRPERIODOAPURACAO
        JOIN GPE_MARCACAOPONTO     MARC ON MARC.NRORG = M.NRORG
                                       AND MARC.NRVINCULOM = M.NRVINCULOM
                                       AND MARC.NRCOLETOR NOT IN (
            SELECT NRCOLETOR
            FROM GPE_PARAMORG
            UNPIVOT (NRCOLETOR FOR NRCOLETOR_TIPO IN (NRCOLETORMARCAUTOM, NRCOLETORMARCGERSIST, NRCOLETORMARCVIRADIA, NRCOLETORMARCPROJETADA ))
            WHERE NRORG = M.NRORG
        )
                                       AND (
            CASE
                WHEN MARC.IDDIAOCORRENCIA IN (
                    'FA',
                    'DA'
                ) THEN
                    TRUNC(MARC.DTHRAJUSTADA) - 1
                WHEN MARC.IDDIAOCORRENCIA IN (
                    'FS',
                    'DS'
                ) THEN
                    TRUNC(MARC.DTHRAJUSTADA) + 1
                ELSE
                    TRUNC(MARC.DTHRAJUSTADA)
            END
        ) BETWEEN PA.DTINICIALAPURACAO AND PA.DTFINALAPURACAO
        JOIN GPE_PESSOAH           PH ON PH.NRORG = M.NRORG
                               AND PH.NRPESSOA = M.NRPESSOA
                               AND PH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_PESSOAH
            WHERE
                NRORG = PH.NRORG
                AND NRPESSOA = PH.NRPESSOA
                AND DTMESCOMPETENC < LAST_DAY(:P_DTMESCOMPETENC)
        )
    WHERE
        M.NRORG = :P_NRORG
        /* FILTROS DE VINCULOS */
        AND ( M.DTRESCISAOVINC IS NULL OR M.DTRESCISAOVINC > LAST_DAY(PA.DTFINALAPURACAO) )
        AND ( INSTR(:NRVINCULOM_LIST, ',' || M.NRVINCULOM || ',') > 0 OR :NRVINCULOM_LIST IS NULL )
        AND ( INSTR(:NRESTRUTLEGAL_LIST, ',' || H.NRESTRUTLEGAL || ',') > 0 OR :NRESTRUTLEGAL_LIST IS NULL )
        AND ( INSTR(:NRESTRUTGEREN_LIST, ',' || H.NRESTRUTGEREN || ',') > 0 OR :NRESTRUTGEREN_LIST IS NULL )
    ORDER BY
        M.NMVINCULOM,
        MARC.DTHRAJUSTADA
),

INTERVALOS AS (
    /* SELECT QUE BUSCA OS INTERVALOS DAS BATIDAS (DUAS A DUAS) IDENTIFICANDO OCORRENCIAS */
    SELECT
        INTERVALOS_PROCESSADOS.*,
    CASE
        WHEN INTERVALOS_PROCESSADOS.TIPO_OCORRENCIA = 'INTERJORNADA' THEN
            CASE
                WHEN INTERVALOS_PROCESSADOS.HRTEMPODESCANSODIARIO > INTERVALOS_PROCESSADOS.DIFF_HOURS THEN
                    'O Funcionário cumpriu um intervalo INFERIOR ao configurado entre jornadas dentre os parâmetros da organização'
                WHEN :P_VALOR IS NOT NULL
                     AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo entre jornadas SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                WHEN :P_VALOR IS NOT NULL
                     AND :P_CONDICAO = 'MENOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo entre jornadas INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                    END
        WHEN INTERVALOS_PROCESSADOS.TIPO_OCORRENCIA = 'INTRAJORNADA' THEN
            CASE
                WHEN INTERVALOS_PROCESSADOS.TEMPO_ALMOCO_HORARIO > INTERVALOS_PROCESSADOS.DIFF_HOURS THEN
                    'O Funcionário cumpriu um intervalo INFERIOR ao configurado em seu horário de trabalho'
                WHEN :P_VALOR IS NOT NULL AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo de descanso SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                WHEN :P_VALOR IS NOT NULL AND :P_CONDICAO = 'MENOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo de descanso INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
            END
        ELSE NULL
    END OBSERVACAO
    FROM
        ( /* SELECT QUE SOMA E ANALISA INTERVALOS */
            SELECT
                INTERVALOS.NRORG,
                INTERVALOS.NRVINCULOM,
                INTERVALOS.NMVINCULOM,
                INTERVALOS.NRPISPASEPPES,
                INTERVALOS.NMVINCULOM || ', PIS: ' || NVL(INTERVALOS.NRPISPASEPPES, 'Não encontrado') AS NMVINCULOM_NOTGROUPED,
                INTERVALOS.HORARIO_INICIO,
                INTERVALOS.IDDIAOCORRENCIA_INICIO,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'HH24:MI') AS HORA_INICIO,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'DD/MM/YYYY') AS DATA_INICIO,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'YYYY-MM-DD') AS DATA_INICIO_FILTER,
                INTERVALOS.HORARIO_FIM,
                INTERVALOS.IDDIAOCORRENCIA_FIM,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'HH24:MI') AS HORA_FIM,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') AS DATA_FIM,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'YYYY-MM-DD') AS DATA_FIM_FILTER,
                ROUND((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24, 5) AS DIFF_HOURS,
                LPAD(TRUNC(((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24)), 2, '0') || ':' || LPAD(ROUND(((((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24) - TRUNC(((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24))) * 60)), 2, '0') DIFF_TIME,
                /* DETERMINA SE O INTERVALO EH INTERJORNADA, INTRAJORNADA OU NENHUM DOS DOIS */
                CASE
                    WHEN ( ( INTERVALOS.IDDIAOCORRENCIA_INICIO IN (
                        'FA',
                        'DA'
                    )
                             AND INTERVALOS.IDDIAOCORRENCIA_FIM NOT IN (
                        'FA',
                        'DA'
                    ) )
                           OR ( INTERVALOS.IDDIAOCORRENCIA_FIM IN (
                        'FS',
                        'DS'
                    )
                                AND INTERVALOS.IDDIAOCORRENCIA_INICIO NOT IN (
                        'FS',
                        'DS'
                    ) )
                           OR ( TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') <> TO_CHAR(INTERVALOS.HORARIO_INICIO, 'DD/MM/YYYY')
                                AND INTERVALOS.IDDIAOCORRENCIA_INICIO IN (
                        'FC',
                        'DC'
                    )
                                AND INTERVALOS.IDDIAOCORRENCIA_FIM IN (
                        'FC',
                        'DC'
                    ) ) ) THEN
                        'INTERJORNADA'
                    WHEN MOD(INTERVALOS.NRORDER_INTERVALO, 2) = 0 THEN
                        'INTRAJORNADA'
                    ELSE
                        ''
                END TIPO_OCORRENCIA, /* TEMPO MINIMO DE DESCANSO ENTRE JORNADAS, DEFINIDO NOS PARAMETROS DA ORGANIZACAO */
                ROUND(TO_NUMBER(SUBSTR(PO.HRTEMPODESCANSODIARIO, 0, 2)) +(TO_NUMBER(SUBSTR(PO.HRTEMPODESCANSODIARIO, 4, 5)) / 60), 5) AS HRTEMPODESCANSODIARIO,
                /* TEMPO A PROJETAR */
                CASE
                    WHEN OC.NRTIPOPROGOCORRENCIA IN (
                        20,
                        26
                    )
                         AND OC.NRINTERVALOHORARIO IS NOT NULL THEN
                        (
                            SELECT
                                ROUND(TO_NUMBER(SUBSTR(HRPROJETARINTERVALO, 0, 2)) +(TO_NUMBER(SUBSTR(HRPROJETARINTERVALO, 3, 4))
                                / 60), 5)
                            FROM
                                GPE_INTERVALOSHORARIO
                            WHERE
                                NRORG = INTERVALOS.NRORG
                                AND NRINTERVALOHORARIO = OC.NRINTERVALOHORARIO
                        )
                    ELSE
                        0
                END TEMPO_ALMOCO_HORARIO
            FROM
                ( /* SELECT QUE AGRUPA AS MARCACOES POR INTERVALOS, DUAS A DUAS */
                    SELECT
                        NRORG,
                        NRVINCULOM,
                        NMVINCULOM,
                        NRPISPASEPPES,
                        NRPERIODOAPURACAO,
                        DATA_APURACAO,
                        TO_CHAR(DTHRAJUSTADA, 'DD/MM/YYYY') AS DTAPURACAOSITUFREQ, /* DTHRAJUSTADA INICIO */
                        DTHRAJUSTADA      AS HORARIO_INICIO, /* DTHRAJUSTADA ANTERIOR */
                        LEAD(DTHRAJUSTADA, 1, TO_DATE('01/01/0001')) OVER(
                            PARTITION BY NRVINCULOM
                            ORDER BY
                                NRVINCULOM, DTHRAJUSTADA
                        ) HORARIO_FIM, /* IDDIAOCORRENCIA INICIO */
                        IDDIAOCORRENCIA   AS IDDIAOCORRENCIA_INICIO, /* IDDIAOCORRENCIA FIM */
                        LEAD(IDDIAOCORRENCIA, 1) OVER(
                            PARTITION BY NRVINCULOM
                            ORDER BY
                                NRVINCULOM, DTHRAJUSTADA
                        ) IDDIAOCORRENCIA_FIM, /* IDDIAOCORRENCIA INICIO */
                        NRMARCACAOPONTO   AS NRMARCACAOPONTO_INICIO,
                        ROW_NUMBER() OVER(
                            PARTITION BY NRVINCULOM, DATA_APURACAO
                            ORDER BY
                                NRVINCULOM, DTHRAJUSTADA
                        ) AS NRORDER_INTERVALO
                    FROM BATIDAS_DIA
                ) INTERVALOS /* OCORRENCIAS ENCONTRADAS PARA O INTERVALO */
                LEFT JOIN PTO_PROGOCORRENCIA OC ON OC.NRORG = INTERVALOS.NRORG
                                                   AND OC.NRMARCACAOPONTO = INTERVALOS.NRMARCACAOPONTO_INICIO
                                                   AND OC.IDATIVO = 'S' /* PARAMETROS DA ORGANIZACAO */
                LEFT JOIN GPE_PARAMORG PO ON PO.NRORG = INTERVALOS.NRORG
            WHERE /* IMPEDE QUE EXISTAM MARCACAOES SEM HORARIO FIM */
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') <> '01/01/0001'
        ) INTERVALOS_PROCESSADOS
)

/* UNION DOS DOIS SELECTS */
SELECT
    OCORRENCIAS.*,
    LIST_BATIDAS.BATIDAS
FROM
    ( /* SELECT QUE GARANTE QUE APENAS INTERVALOS COM OCORRENCIA SEJAM BUSCADOS */
        SELECT
            NRORG,
            NRVINCULOM,
            NMVINCULOM,
            NRPISPASEPPES,
            NMVINCULOM_NOTGROUPED,
            HORARIO_INICIO,
            IDDIAOCORRENCIA_INICIO,
            HORA_INICIO,
            DATA_INICIO,
            DATA_INICIO_FILTER,
            HORARIO_FIM,
            IDDIAOCORRENCIA_FIM,
            HORA_FIM,
            DATA_FIM,
            DATA_FIM_FILTER,
            DIFF_HOURS,
            DIFF_TIME,
            TIPO_OCORRENCIA,
            HRTEMPODESCANSODIARIO,
            TEMPO_ALMOCO_HORARIO,
            OBSERVACAO
        FROM
            INTERVALOS
        WHERE
            /* GARANTE QUE APENAS INTERVALOS COM OCORRENCIAS SEJAM BUSCADOS */
            TIPO_OCORRENCIA IS NOT NULL
            
        UNION ALL
        
        /* SELECT QUE BUSCA OCORRENCIAS QUE NAO DEPENDEM DOS INTERVALOS - ABONO, IMPAR, EXTRA */
        SELECT
            NRORG,
            NRVINCULOM,
            NMVINCULOM,
            NRPISPASEPPES,
            NMVINCULOM || ', PIS: ' || NVL(NRPISPASEPPES, 'Não encontrado') AS NMVINCULOM_NOTGROUPED,
            DTDATA            AS HORARIO_INICIO,
            NULL AS IDDIAOCORRENCIA_INICIO,
            NULL AS HORA_INICIO,
            TO_CHAR(DTDATA, 'DD/MM/YYYY') AS DATA_INICIO,
            TO_CHAR(DTDATA, 'YYYY-MM-DD') AS DATA_INICIO_FILTER,
            NULL AS HORARIO_FIM,
            NULL AS IDDIAOCORRENCIA_FIM,
            NULL AS HORA_FIM,
            NULL AS DATA_FIM,
            NULL AS DATA_FIM_FILTER,
            CASE
                WHEN TIPO_OCORRENCIA = 'EXTRA'  THEN
                    VALOR_EXTRA_HOURS
                WHEN TIPO_OCORRENCIA = 'ATRASO' THEN
                    VALOR_ATRASO_HOURS
                ELSE
                    NULL
            END AS DIFF_HOURS,
            CASE
                WHEN TIPO_OCORRENCIA = 'EXTRA'  THEN
                    VALOR_EXTRA_TIME
                WHEN TIPO_OCORRENCIA = 'ATRASO' THEN
                    VALOR_ATRASO_TIME
                ELSE
                    NULL
            END AS DIFF_TIME,
            TIPO_OCORRENCIA   AS TIPO_OCORRENCIA,
            NULL AS HRTEMPODESCANSODIARIO,
            NULL AS TEMPO_ALMOCO_HORARIO,
            OBSERVACAO
        FROM
            TOTALIZADORES
        UNPIVOT (OBSERVACAO FOR TIPO_OCORRENCIA IN (ABONO, QTD_MARCACAOES_IMPAR, EXTRA, FALTA, ATRASO, TROCA ))
    ) OCORRENCIAS
    
    /* BUSCA POR INFORMACOES PARA TODOS OS DADOS ALEM DO UNION */
    
    /* RETORNA AS BATIDAS REALIZADAS NO DIA */
    LEFT JOIN (
        SELECT
            NRVINCULOM,
            DATA_APURACAO,
            LISTAGG(TO_CHAR(DTHRAJUSTADA, 'HH24:MI'), ' - ') WITHIN GROUP (ORDER BY NRVINCULOM, DTHRAJUSTADA) BATIDAS
        FROM BATIDAS_DIA
        GROUP BY NRVINCULOM, DATA_APURACAO
    ) LIST_BATIDAS ON LIST_BATIDAS.NRVINCULOM = OCORRENCIAS.NRVINCULOM AND TRUNC(LIST_BATIDAS.DATA_APURACAO) = TRUNC(OCORRENCIAS.HORARIO_INICIO)
WHERE
    ( ( INSTR(:P_TIPOOCORRENCIA, ','
                                 || TIPO_OCORRENCIA
                                 || ',') ) > 0
      OR :P_TIPOOCORRENCIA IS NULL )
    AND /* OPCOES DE FILTRO: MENOR_IGUAL, MAIOR_IGUAL, IGUAL */ ( :P_CONDICAO IS NOT NULL
          AND ( ( :P_CONDICAO = 'MAIOR_IGUAL'
                  AND DIFF_HOURS >= ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) +(TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5) )
                OR ( :P_CONDICAO = 'MENOR_IGUAL'
                     AND DIFF_HOURS <= ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) +(TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5) )
                OR ( :P_CONDICAO = 'IGUAL'
                     AND DIFF_HOURS = ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) +(TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5) ) )
          OR :P_CONDICAO IS NULL )
ORDER BY
    NMVINCULOM,
    TRUNC(HORARIO_INICIO),
    HORARIO_FIM
NULLS LAST
;