/*
Execuo: 
 @C:\WIN_PRJ\CLIENTES\PAMPAS\SQL\CORRIGE_CONTAS_FISCAL.SQL

Descrio:
   - Script para atualizar a data de Emisso e data de Sada das notas fiscais que foram
       geradas no programa FIS00200 (Preparao de Pagamentos);
   - Ser atualizado o fluxo de caixa, caso esteja incorreto

Criao:
  17/09/2002  - Jenilson Ferreira

*/

DECLARE
    V_DTEMISSAO NOTAFISCAL.DTEMISSAO%TYPE;
    V_DTENTRSAI NOTAFISCAL.DTEMISSAO%TYPE;
BEGIN
   FOR C_NFPAG IN (SELECT CDFILIAL,   NRLANCTONF, DTEMISSAO,
                          DTENTRSAID, CDFORNECED, IDTPIJURNF,
                          NRINSJURNF,
                          SUBSTR(CDFORNECED, 1, 1) IDTPFORN,
                          SUBSTR(CDFORNECED, 2, LENGTH(CDFORNECED)) NRTPFORN
                   FROM NOTAFISCAL
                   WHERE (IDSISTEMA = 'PAG')  AND
                         (DTEMISSAO  IS NULL) AND
                         (DTENTRSAID IS NULL)) LOOP

      FOR C_CTPAG IN (SELECT CDFILIAL,     NRLANCTONF,   NRSEQVENPAG,
                             NRPARCELAPAG, CDCLASSFINA,  CDEMPRESA,
                             CDFIMOVFLPAG, DTMOVFLUXO,   IDMOVFLUXO,
                             IDSTATPAG,    DTORIGVENPAG, VRORIGPAG
                      FROM CONTAPAGAR
                      WHERE CDFILIAL   = C_NFPAG.CDFILIAL  AND
                            NRLANCTONF = C_NFPAG.NRLANCTONF
                      ORDER BY CDFILIAL,    NRLANCTONF,
                               NRSEQVENPAG, NRPARCELAPAG) LOOP

         IF C_CTPAG.IDSTATPAG = 'A' AND C_CTPAG.IDMOVFLUXO = 'R' THEN
            ATUALIZA_FLUXO_DE_CAIXA(C_CTPAG.CDEMPRESA,
                                    C_CTPAG.CDFIMOVFLPAG,
                                    C_CTPAG.DTMOVFLUXO,
                                    C_CTPAG.IDMOVFLUXO,
                                    C_CTPAG.CDCLASSFINA,
                                    0,
                                    C_CTPAG.VRORIGPAG * -1);

            ATUALIZA_FLUXO_DE_CAIXA(C_CTPAG.CDEMPRESA,
                                    C_CTPAG.CDFIMOVFLPAG,
                                    C_CTPAG.DTMOVFLUXO,
                                    'E',
                                    C_CTPAG.CDCLASSFINA,
                                    0,
                                    C_CTPAG.VRORIGPAG);
            UPDATE CONTAPAGAR
            SET IDMOVFLUXO = 'E'
            WHERE CDFILIAL     = C_CTPAG.CDFILIAL     AND
                  NRLANCTONF   = C_CTPAG.NRLANCTONF   AND
                  NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG  AND
                  NRPARCELAPAG = C_CTPAG.NRPARCELAPAG;
         END IF;

      END LOOP;

      SELECT MIN(DTORIGVENPAG), MIN(DTORIGVENPAG)
      INTO V_DTEMISSAO, V_DTENTRSAI
      FROM CONTAPAGAR
      WHERE CDFILIAL   = C_NFPAG.CDFILIAL  AND
            NRLANCTONF = C_NFPAG.NRLANCTONF
      ORDER BY CDFILIAL,    NRLANCTONF,
               NRSEQVENPAG, NRPARCELAPAG;

      UPDATE NOTAFISCAL
      SET DTEMISSAO  = V_DTEMISSAO,
          DTENTRSAID = V_DTENTRSAI,
          IDTPIJURNF = C_NFPAG.IDTPFORN,
          NRINSJURNF = C_NFPAG.NRTPFORN
      WHERE CDFILIAL   = C_NFPAG.CDFILIAL  AND
            NRLANCTONF = C_NFPAG.NRLANCTONF;

   END LOOP;
END;
/

COMMIT
/


